'To be able to compile with firstbas, all subroutines return a value,
'all variables are global and constants can be changed. :-)

DIM wizname$(9)
DIM alive%(9)
DIM sequence$(9, 1)
DIM visibleseq$(9, 1)
DIM newsign$(9, 1)
DIM spell$(9, 1, 2)
DIM health%(9)
DIM specbolt%(9)
DIM dispell%(9)
DIM shield%(9)
DIM counter%(9)
DIM mirror%(9)
DIM invis%(9, 2)
DIM blind%(9, 2)
DIM delayed%(9, 1)
DIM storedspell$(9)
DIM haste%(9, 2)
DIM perm%(9, 1)
DIM protect%(9, 2)
DIM timestop%(9, 1)
DIM res%(9, 2, 2)
DIM poison%(9, 1)
DIM disease%(9, 1)
DIM scramble%(9)
DIM amnesia%(9)
DIM confusion%(9)
DIM paralysis%(9)
DIM fear%(9)
DIM charmed%(9, 2)
DIM mindcount%(9)
DIM goblins%(9)
DIM ogres%(9)
DIM trolls%(9)
DIM giants%(9)
DIM elemental%(9, 2)
DIM control%(9)

TRUE = -1
FALSE = 0
LEFT = 0
RIGHT = 1
TAG = 0
COUNT = 1
PERMANENT = 2
HEAT = 0
COLD = 1
SPSTOP = 0
SPHASTE = 1
SPNORM = 2

DEF FNnogesture% (word$)
	SELECT CASE word$
	CASE "d", "f", "p", "s", "w", "x"
		FNnogesture% = FALSE
	CASE ELSE
		FNnogesture% = TRUE
	END SELECT
END DEF

DEF FNnamex$ (index%)
	SELECT CASE index%
		CASE 1
			FNnamex$ = "Asterix"
		CASE 2
			FNnamex$ = "Obelix"
		CASE 3
			FNnamex$ = "Camembertix"
		CASE 4
			FNnamex$ = "Duvinix"
		CASE 5
			FNnamex$ = "Eaudecolognix"
		CASE 6
			FNnamex$ = "Fetix"
		CASE 7
			FNnamex$ = "Grandprix"
		CASE 8
			FNnamex$ = "Helix"
		CASE 9
			FNnamex$ = "Mister Sinister"
	END SELECT
END DEF

DEF FNshowwizards (index%)
	CLS
	FOR i% = 1 TO spelers%
		IF i% = index% THEN COLOR 15
		IF i% = index% OR NOT blind%(i%, TAG) THEN
			PRINT "Wizard"; i%; ": "; wizname$(i%); SPACE$(20 - LEN(wizname$(i%)));
			IF NOT alive%(i%) THEN PRINT "Dead" ELSE PRINT "Health:"; health%(i%)
			IF invis%(i%, TAG) THEN
				IF invis%(i%, PERMANENT) THEN PRINT "Permanently ";
				PRINT "Invisible  ";
			END IF
			IF blind%(i%, TAG) THEN
				IF blind%(i%, PERMANENT) THEN PRINT "Permanently ";
				PRINT "Blind  ";
			END IF
			IF delayed%(i%, TAG) THEN PRINT "Delayed Effect  ";
			IF haste%(i%, TAG) THEN
				IF haste%(i%, PERMANENT) THEN PRINT "Permanent ";
				PRINT "Haste  ";
			END IF
			IF perm%(i%, TAG) THEN PRINT "Permanence  ";
			IF protect%(i%, TAG) THEN
				IF protect%(i%, PERMANENT) THEN PRINT "Permanent ";
				PRINT "Protection  ";
			END IF
			IF timestop%(i%, TAG) THEN PRINT "Time Stop";
			IF res%(i%, TAG, HEAT) THEN
				IF res%(i%, PERMANENT, HEAT) THEN PRINT "Permanent ";
				PRINT "Resist Heat  ";
			END IF
			IF res%(i%, TAG, COLD) THEN
				IF res%(i%, PERMANENT, COLD) THEN PRINT "Permanent ";
				PRINT "Resist Cold  ";
			END IF
			IF mindcount%(i%) = 1 THEN
				IF scramble%(i%) THEN
					PRINT "Scrambled  ";
				ELSEIF amnesia%(i%) THEN
					PRINT "Amnesia  ";
				ELSEIF confusion%(i%) THEN
					PRINT "Confused  ";
				ELSEIF paralysis%(i%) THEN
					PRINT "Paralyzed  ";
				ELSEIF fear%(i%) THEN
					PRINT "Frightened  ";
				ELSEIF charmed%(i%, TAG) THEN
					PRINT "Charmed by "; wizname$(charmed%(i%, COUNT));
				END IF
			END IF
			IF invis%(i%, TAG) OR blind%(i%, TAG) OR delayed%(i%, TAG) OR haste%(i%, TAG) OR perm%(i%, TAG) OR protect%(i%, TAG) OR timestop%(i%, TAG) OR res%(i%, TAG, HEAT) OR res%(i%, TAG, COLD) OR mindcount%(i%) = 1 THEN PRINT
			IF poison%(i%, TAG) THEN PRINT "Poisoned :"; poison%(i%, COUNT); "turns to live"
			IF disease%(i%, TAG) THEN PRINT "Diseased :"; disease%(i%, COUNT); "turns to live"
			IF storedspell$(i%) <> "" THEN PRINT "Delayed Spell: "; storedspell$(i%)
			IF goblins%(i%) > 0 OR ogres%(i%) > 0 OR trolls%(i%) > 0 OR giants%(i%) > 0 OR elemental%(i%, HEAT) OR elemental%(i%, COLD) THEN
				PRINT "Army:";
				IF goblins%(i%) > 0 THEN
					PRINT " "; goblins%(i%); "Goblin";
					IF goblins%(i%) > 1 THEN PRINT "s";
				END IF
				IF ogres%(i%) > 0 THEN
					PRINT " "; ogres%(i%); "Ogre";
					IF ogres%(i%) > 1 THEN PRINT "s";
				END IF
				IF trolls%(i%) > 0 THEN
					PRINT " "; trolls%(i%); "Troll";
					IF trolls%(i%) > 1 THEN PRINT "s";
				END IF
				IF giants%(i%) > 0 THEN
					PRINT " "; giants%(i%); "Giant";
					IF giants%(i%) > 1 THEN PRINT "s";
				END IF
				IF elemental%(i%, HEAT) THEN PRINT "  1 Fire Elemental";
				IF elemental%(i%, COLD) THEN PRINT "  1 Ice Elemental";
				PRINT
			END IF
			IF control%(i%) <> i% THEN
				PRINT "Under control of "; wizname$(control%(i%))
			END IF
			IF i% <> index% THEN
				PRINT "Left : "; visibleseq$(i%, LEFT); "    ";
				IF spell$(i%, LEFT, SPSTOP) <> "" THEN PRINT spell$(i%, LEFT, SPSTOP); "  ";
				IF spell$(i%, LEFT, SPHASTE) <> "" THEN PRINT spell$(i%, LEFT, SPHASTE); "  ";
				PRINT spell$(i%, LEFT, SPNORM)
				PRINT "Right: "; visibleseq$(i%, RIGHT); "    ";
				IF spell$(i%, RIGHT, SPSTOP) <> "" THEN PRINT spell$(i%, RIGHT, SPSTOP); "  ";
				IF spell$(i%, RIGHT, SPHASTE) <> "" THEN PRINT spell$(i%, RIGHT, SPHASTE); "  ";
				PRINT spell$(i%, RIGHT, SPNORM)
			ELSE
				PRINT "Left : "; sequence$(i%, LEFT); "    ";
				IF spell$(i%, LEFT, SPSTOP) <> "" THEN PRINT spell$(i%, LEFT, SPSTOP); "  ";
				IF spell$(i%, LEFT, SPHASTE) <> "" THEN PRINT spell$(i%, LEFT, SPHASTE); "  ";
				PRINT spell$(i%, LEFT, SPNORM)
				PRINT "Right: "; sequence$(i%, RIGHT); "    ";
				IF spell$(i%, RIGHT, SPSTOP) <> "" THEN PRINT spell$(i%, RIGHT, SPSTOP); "  ";
				IF spell$(i%, RIGHT, SPHASTE) <> "" THEN PRINT spell$(i%, RIGHT, SPHASTE); "  ";
				PRINT spell$(i%, RIGHT, SPNORM)
			END IF
		END IF
		PRINT
		IF i% = index% THEN COLOR 7
	NEXT
	FNshowwizards = TRUE
END DEF

DEF FNkillmonsters (index%)
	goblins%(index%) = 0
	ogres%(index%) = 0
	trolls%(index%) = 0
	giants%(index%) = 0
	FNkillmonsters = TRUE
END DEF

DEF FNpresskey
	WHILE INKEY$ = ""
	WEND
	FNpresskey = TRUE
END DEF

DEF FNnextwiz% (index%, side%)
	IF side% = LEFT THEN
		temp% = index%
		DO
			IF temp% = 1 THEN
				temp% = spelers%
			ELSE
				temp% = temp% - 1
			END IF
		LOOP WHILE NOT alive%(temp%)
	ELSE
		temp% = index%
		DO
			IF temp% = spelers% THEN
				temp% = 1
			ELSE
				temp% = temp% + 1
			END IF
		LOOP WHILE NOT alive%(temp%)
	END IF
	FNnextwiz% = temp%
END DEF

DEF FNextro
	IF (levenden% = 1) THEN
		x = FNshowwizards(FNnextwiz%(1, RIGHT))
	ELSE
		CLS
		LOCATE 10, 20
		PRINT "All wizards are dead."
	END IF
	FNextro = TRUE
END DEF

DEF FNinit
	RANDOMIZE TIMER

	CLS
	INPUT "How many wizards"; spelers%
	IF spelers% < 2 THEN spelers% = 2
	IF spelers% > 9 THEN spelers% = 9
	levenden% = spelers%

	FOR i% = 1 TO spelers%
		PRINT
		PRINT "Name of wizard"; i%;
		INPUT wizname$(i%)
		IF wizname$(i%) = "" THEN wizname$(i%) = FNnamex$(i%)
		alive%(i%) = TRUE
		sequence$(i%, LEFT) = "----------"
		sequence$(i%, RIGHT) = "----------"
		visibleseq$(i%, LEFT) = "----------"
		visibleseq$(i%, RIGHT) = "----------"
		FOR t% = SPSTOP TO SPNORM
			spell$(i%, LEFT, t%) = ""
			spell$(i%, RIGHT, t%) = ""
		NEXT
		health%(i%) = 15
		storedspell$ = ""
		control%(i%) = i%
	NEXT
	FNinit = TRUE
END DEF

DEF FNshiftsequence (index%, hide%)
	sequence$(index%, LEFT) = RIGHT$(sequence$(index%, LEFT) + newsign$(index%, LEFT), 10)
	sequence$(index%, RIGHT) = RIGHT$(sequence$(index%, RIGHT) + newsign$(index%, RIGHT), 10)
	IF hide% THEN
		visibleseq$(index%, LEFT) = RIGHT$(visibleseq$(index%, LEFT) + "?", 10)
		visibleseq$(index%, RIGHT) = RIGHT$(visibleseq$(index%, RIGHT) + "?", 10)
	ELSE
		visibleseq$(index%, LEFT) = RIGHT$(visibleseq$(index%, LEFT) + newsign$(index%, LEFT), 10)
		visibleseq$(index%, RIGHT) = RIGHT$(visibleseq$(index%, RIGHT) + newsign$(index%, RIGHT), 10)
	END IF
	FNshiftsequence = TRUE
END DEF

DEF FNcheckforkills
	FOR i% = 1 TO spelers%
		IF alive%(i%) AND health%(i%) <= 0 THEN
			alive%(i%) = FALSE
			health%(i%) = 0
			IF NOT res%(i%, PERMANENT, HEAT) THEN res%(i%, TAG, HEAT) = FALSE
			IF NOT res%(i%, PERMANENT, COLD) THEN res%(i%, TAG, COLD) = FALSE
			IF NOT blind%(i%, PERMANENT) THEN blind%(i%, TAG) = FALSE
			IF NOT invis%(i%, PERMANENT) THEN invis%(i%, TAG) = FALSE
			IF NOT haste%(i%, PERMANENT) THEN haste%(i%, TAG) = FALSE
			IF NOT protect%(i%, PERMANENT) THEN protect%(i%, TAG) = FALSE
			perm%(i%, TAG) = FALSE
			delayed%(i%, TAG) = FALSE
			storedspell$(i%) = ""
			timestop%(i%, TAG) = FALSE
			poison%(i%, TAG) = FALSE
			disease%(i%, TAG) = FALSE
			x = FNkillmonsters(i%)
			elemental%(i%, HEAT) = FALSE
			elemental%(i%, COLD) = FALSE
			scramble%(i%) = FALSE
			amnesia%(i%) = FALSE
			confusion%(i%) = FALSE
			paralysis%(i%) = FALSE
			fear%(i%) = FALSE
			charmed%(i%, TAG) = FALSE
			FOR j% = 1 TO spelers%
				IF health%(j%) > 0 AND control%(j%) = i% THEN
					control%(j%) = j%
					levenden% = levenden% + 1
				END IF
			NEXT
			IF control%(i%) = i% THEN levenden% = levenden% - 1
		END IF
	NEXT
END DEF

DEF FNresolvespells
	'reset
	FOR i% = 1 TO spelers%
		dispell%(i%) = FALSE
		shield%(i%) = FALSE
		counter%(i%) = FALSE
		mirror%(i%) = FALSE
		scramble%(i%) = FALSE
		amnesia%(i%) = FALSE
		confusion%(i%) = FALSE
		charmed%(i%, TAG) = FALSE
		paralysis%(i%) = FALSE
		fear%(i%) = FALSE
		mindcount%(i%) = 0
		IF NOT alive%(i%) THEN
			sequence$(i%, LEFT) = "----------"
			sequence$(i%, RIGHT) = "----------"
			visibleseq$(i%, LEFT) = "----------"
			visibleseq$(i%, RIGHT) = "----------"
			FOR t% = SPSTOP TO SPNORM
				spell$(i%, LEFT, t%) = ""
				spell$(i%, RIGHT, t%) = ""
			NEXT
		END IF
	NEXT

	'Surrender
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			IF spell$(i%, LEFT, t%) = "Surrender" THEN health%(i%) = 0
		NEXT
	NEXT

	'transfer vertraagde spreuken
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			IF storedspell$(i%) <> "" THEN
				IF spell$(i%, LEFT, t%) = "Stab" THEN
					spell$(i%, LEFT, t%) = storedspell$(i%)
					storedspell$(i%) = ""
				ELSEIF spell$(i%, RIGHT, t%) = "Stab" THEN
					spell$(i%, RIGHT, t%) = storedspell$(i%)
					storedspell$(i%) = ""
				END IF
			END IF
			IF delayed%(i%, TAG) THEN
				IF spell$(i%, LEFT, t%) <> "" AND spell$(i%, LEFT, t%) <> "Stab" THEN
					storedspell$(i%) = spell$(i%, LEFT, t%)
					spell$(i%, LEFT, t%) = ""
					delayed%(i%, TAG) = FALSE
				ELSEIF spell$(i%, RIGHT, t%) <> "" AND spell$(i%, RIGHT, t%) <> "Stab" THEN
					storedspell$(i%) = spell$(i%, LEFT, t%)
					spell$(i%, RIGHT, t%) = ""
					delayed%(i%, TAG) = FALSE
				END IF
			END IF
		NEXT
	NEXT

	'instelling dispell
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			FOR side% = LEFT TO RIGHT
				IF spell$(i%, side%, t%) = "Dispell Magic" THEN
					dispell%(FNnextwiz%(i%, LEFT)) = TRUE
					dispell%(i%) = TRUE
					dispell%(FNnextwiz%(i%, RIGHT)) = TRUE
					shield%(i%) = TRUE
				END IF
			NEXT
		NEXT
	NEXT

	'dispell: hef enchantments op
	FOR i% = 1 TO spelers%
		IF dispell%(i%) THEN
			IF NOT res%(i%, PERMANENT, HEAT) THEN res%(i%, TAG, HEAT) = FALSE
			IF NOT res%(i%, PERMANENT, COLD) THEN res%(i%, TAG, COLD) = FALSE
			IF NOT blind%(i%, PERMANENT) THEN blind%(i%, TAG) = FALSE
			IF NOT invis%(i%, PERMANENT) THEN invis%(i%, TAG) = FALSE
			IF NOT haste%(i%, PERMANENT) THEN haste%(i%, TAG) = FALSE
			IF NOT protect%(i%, PERMANENT) THEN protect%(i%, TAG) = FALSE
			perm%(i%, TAG) = FALSE
			delayed%(i%, TAG) = FALSE
			timestop%(i%, TAG) = FALSE
			poison%(i%, TAG) = FALSE
			disease%(i%, TAG) = FALSE
		END IF
	NEXT

	'countermagie en shield instellen
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			IF protect%(i%, TAG) THEN shield%(i%) = TRUE
			IF NOT dispell%(i%) THEN
				FOR side% = LEFT TO RIGHT
					SELECT CASE spell$(i%, side%, t%)
					CASE "Shield"
						shield%(i%) = TRUE
					CASE "Counterspell"
						counter%(i%) = TRUE
						shield%(i%) = TRUE
					END SELECT
				NEXT
			END IF
		NEXT
	NEXT

	'mirror instellen
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			IF NOT dispell%(i%) AND NOT counter%(i%) THEN
				IF spell$(i%, LEFT, t%) = "Magic Mirror" THEN mirror%(i%) = TRUE
				IF spell$(i%, RIGHT, t%) = "Magic Mirror" THEN mirror%(i%) = TRUE
			END IF
		NEXT
	NEXT

	'stab
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			FOR side% = LEFT TO RIGHT
				victim% = FNnextwiz%(i%, side%)
				IF spell$(i%, side%, t%) = "Stab" AND NOT shield%(victim%) AND NOT invis%(victim%, TAG) THEN
					health%(victim%) = health%(victim%) - 1
				END IF
			NEXT
		NEXT
	NEXT

	'targeted spells
	FOR i% = 1 TO spelers%
		FOR t% = SPSTOP TO SPNORM
			IF NOT dispell%(i%) THEN
				FOR side% = LEFT TO RIGHT
					victim% = FNnextwiz%(i%, side%)
					IF mirror%(victim%) THEN victim% = i%
					IF NOT invis%(victim%, TAG) AND spell$(i%, side%, t%) = "Finger of Death" THEN
						health%(victim%) = 0
					ELSEIF NOT counter%(victim%) AND NOT invis%(victim%, TAG) THEN
					   SELECT CASE spell$(i%, side%, t%)
						CASE "Missile"
							IF NOT shield%(victim%) THEN health%(victim%) = health%(victim%) - 1
						CASE "Minor Harm"
							health%(victim%) = health%(victim%) - 2
						CASE "Major Harm"
							health%(victim%) = health%(victim%) - 3
						CASE "Lightning Bolt"
							health%(victim%) = health%(victim%) - 5
						CASE "Special Bolt"
							IF NOT specbolt%(i%) THEN health%(victim%) = health%(victim%) - 5
							specbolt%(i%) = TRUE
						CASE "Fireball"
							IF NOT res%(victim%, TAG, HEAT) THEN health%(victim%) = health%(victim%) - 5
						CASE "Poison"
							poison%(victim%, TAG) = TRUE
							poison%(victim%, COUNT) = 7
						CASE "Disease"
							disease%(victim%, TAG) = TRUE
							disease%(victim%, COUNT) = 7
						CASE "Blindness"
							blind%(victim%, TAG) = TRUE
							IF perm%(i%, TAG) THEN
								perm%(i%, TAG) = FALSE
								blind%(victim%, PERMANENT) = TRUE
							ELSE
								blind%(victim%, COUNT) = 4
							END IF
						CASE "Scramble"
							scramble%(victim%) = TRUE
							mindcount%(victim%) = mindcount%(victim%) + 1
						CASE "Amnesia"
							amnesia%(victim%) = TRUE
							mindcount%(victim%) = mindcount%(victim%) + 1
						CASE "Confusion"
							confusion%(victim%) = TRUE
							mindcount%(victim%) = mindcount%(victim%) + 1
						CASE "Paralyze"
							paralysis%(victim%) = TRUE
							mindcount%(victim%) = mindcount%(victim%) + 1
						CASE "Fear"
							fear%(victim%) = TRUE
							mindcount%(victim%) = mindcount%(victim%) + 1
						END SELECT
					END IF
				NEXT
			END IF
		NEXT
	NEXT
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				FOR side% = LEFT TO RIGHT
					victim% = FNnextwiz%(i%, side%)
					IF NOT mirror%(victim%) AND NOT counter%(victim%) AND NOT invis%(victim%, TAG) THEN
						SELECT CASE spell$(i%, side%, t%)
						CASE "Charm Monster"
							IF giants%(victim%) > 0 THEN
								giants%(victim%) = giants%(victim%) - 1
								giants%(victim%) = giants%(victim%) + 1
							ELSEIF elemental%(victim%, HEAT) THEN
								elemental%(victim%, HEAT) = FALSE
								elemental%(i%, HEAT) = TRUE
							ELSEIF elemental%(victim%, COLD) THEN
								elemental%(victim%, COLD) = FALSE
								elemental%(i%, COLD) = TRUE
							ELSEIF trolls%(victim%) > 0 THEN
								trolls%(victim%) = trolls%(victim%) - 1
								trolls%(victim%) = trolls%(victim%) + 1
							ELSEIF ogres%(victim%) > 0 THEN
								ogres%(victim%) = ogres%(victim%) - 1
								ogres%(victim%) = ogres%(victim%) + 1
							ELSEIF goblins%(victim%) > 0 THEN
								goblins%(victim%) = goblins%(victim%) - 1
								goblins%(victim%) = goblins%(victim%) + 1
							END IF
						CASE "Charm Person"
							charmed%(victim%, TAG) = TRUE
							charmed%(victim%, COUNT) = i%
							mindcount%(victim%) = mindcount%(victim%) + 1
						END SELECT
					END IF
				NEXT
			NEXT
		END IF
	NEXT
	FOR i% = 1 TO spelers%
		IF mindcount%(i%) > 1 THEN
			scramble%(i%) = FALSE
			amnesia%(i%) = FALSE
			confusion%(i%) = FALSE
			paralysis%(i%) = FALSE
			fear%(i%) = FALSE
			charmed%(i%, TAG) = FALSE
		END IF
		IF scramble%(i%) THEN
			sequence$(i%, LEFT) = "----------"
			sequence$(i%, RIGHT) = "----------"
			visibleseq$(i%, LEFT) = "----------"
			visibleseq$(i%, RIGHT) = "----------"
		END IF
	NEXT

	'monster attacks
	FOR i% = 1 TO spelers%
		IF RND < .5 AND NOT shield%(FNnextwiz%(i%, LEFT)) THEN
			victim% = FNnextwiz%(i%, LEFT)
		ELSE
			victim% = FNnextwiz%(i%, RIGHT)
		END IF
		IF NOT shield%(victim%) AND NOT invis%(victim%, TAG) THEN
			damage% = goblins%(i%) + 2 * ogres%(i%) + 3 * trolls%(i%) + 4 * giants%(i%)
			health%(victim%) = health%(victim%) - damage%
		END IF
	NEXT

	'monster summons
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				FOR side% = LEFT TO RIGHT
					SELECT CASE spell$(i%, side%, t%)
					CASE "Summon Goblin"
						goblins%(i%) = goblins%(i%) + 1
					CASE "Summon Ogre"
						ogres%(i%) = ogres%(i%) + 1
					CASE "Summon Troll"
						trolls%(i%) = trolls%(i%) + 1
					CASE "Summon Giant"
						giants%(i%) = giants%(i%) + 1
					END SELECT
				NEXT
			NEXT
		END IF
	NEXT

	'elemental damage
	FOR i% = 1 TO spelers%
		lwiz% = FNnextwiz%(i%, LEFT)
		rwiz% = FNnextwiz%(i%, RIGHT)
		FOR element% = HEAT TO COLD
			IF elemental%(i%, element%) THEN
				IF NOT shield%(lwiz%) AND NOT res%(lwiz%, TAG, element%) THEN health%(lwiz%) = health%(lwiz%) - 3
				IF NOT shield%(i%) AND NOT res%(i%, TAG, element%) THEN health%(i%) = health%(i%) - 3
				IF lwiz% <> rwiz% AND NOT shield%(rwiz%) AND NOT res%(rwiz%, TAG, element%) THEN health%(rwiz%) = health%(rwiz%) - 3
				goblins%(lwiz%) = 0
				ogres%(lwiz%) = 0
				trolls%(lwiz%) = 0
				goblins%(i%) = 0
				ogres%(i%) = 0
				trolls%(i%) = 0
				goblins%(rwiz%) = 0
				ogres%(rwiz%) = 0
				trolls%(rwiz%) = 0
			END IF
		NEXT
	NEXT

	'elemental summons
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				IF spell$(i%, LEFT, t%) = "Elemental" THEN
					element% = HEAT
					anti% = COLD
					summon% = TRUE
				ELSEIF spell$(i%, RIGHT, t%) = "Elemental" THEN
					element% = COLD
					anti% = HEAT
					summon% = TRUE
				ELSE
					summon% = FALSE
				END IF
				IF summon% THEN
					lwiz% = FNnextwiz%(i%, LEFT)
					rwiz% = FNnextwiz%(i%, RIGHT)
					IF elemental%(lwiz%, anti%) OR elemental%(i%, anti%) OR elemental%(rwiz%, anti%) THEN
						elemental%(lwiz%, anti%) = FALSE
						elemental%(i%, anti%) = FALSE
						elemental%(rwiz%, anti%) = FALSE
					ELSE
						elemental%(i%, element%) = TRUE
					END IF
				END IF
			NEXT
		END IF
	NEXT

	'storms
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				lwiz% = FNnextwiz%(i%, LEFT)
				rwiz% = FNnextwiz%(i%, RIGHT)
				FOR side% = LEFT TO RIGHT
					SELECT CASE spell$(i%, side%, t%)
					CASE "Fire Storm"
						element% = HEAT
						anti% = COLD
						storm% = TRUE
					CASE "Ice Storm"
						element% = COLD
						anti% = HEAT
						storm% = TRUE
					CASE ELSE
						storm% = FALSE
					END SELECT
					IF storm% THEN
						IF elemental%(lwiz%, anti%) OR elemental%(i%, anti%) OR elemental%(rwiz%, anti%) THEN
							elemental%(lwiz%, anti%) = FALSE
							elemental%(i%, anti%) = FALSE
							elemental%(rwiz%, anti%) = FALSE
						ELSE
							x = FNkillmonsters(lwiz%)
							IF NOT res%(lwiz%, TAG, element%) AND NOT counter%(lwiz%) THEN health%(lwiz%) = health%(lwiz%) - 5
							x = FNkillmonsters(i%)
							IF NOT res%(i%, TAG, element%) AND NOT counter%(i%) THEN health%(i%) = health%(i%) - 5
							IF lwiz% <> rwiz% THEN
								x = FNkillmonsters(rwiz%)
								IF NOT res%(rwiz%, TAG, element%) AND NOT counter%(rwiz%) THEN health%(rwiz%) = health%(rwiz%) - 5
							END IF
						END IF
					END IF
				NEXT
			NEXT
		END IF
	NEXT

	'positive enchantments
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) AND NOT counter%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				FOR side% = LEFT TO RIGHT
					SELECT CASE spell$(i%, side%, t%)
					CASE "Invisibility"
						invis%(i%, TAG) = TRUE
						IF perm%(i%, TAG) THEN
							perm%(i%, TAG) = FALSE
							invis%(i%, PERMANENT) = TRUE
						ELSE
							invis%(i%, COUNT) = 4
						END IF
					CASE "Protection"
						protect%(i%, TAG) = TRUE
						IF perm%(i%, TAG) THEN
							perm%(i%, TAG) = FALSE
							protect%(i%, PERMANENT) = TRUE
						ELSE
							protect%(i%, COUNT) = 4
						END IF
					CASE "Resist Heat"
						res%(i%, TAG, HEAT) = TRUE
						IF perm%(i%, TAG) THEN
							perm%(i%, TAG) = FALSE
							res%(i%, PERMANENT, HEAT) = TRUE
						ELSE
							res%(i%, COUNT, HEAT) = 4
						END IF
					CASE "Resist Cold"
						res%(i%, TAG, COLD) = TRUE
						IF perm%(i%, TAG) THEN
							perm%(i%, TAG) = FALSE
							res%(i%, PERMANENT, COLD) = TRUE
						ELSE
							res%(i%, COUNT, COLD) = 4
						END IF
					CASE "Haste"
						haste%(i%, TAG) = TRUE
						IF perm%(i%, TAG) THEN
							perm%(i%, TAG) = FALSE
							haste%(i%, PERMANENT) = TRUE
						ELSE
							haste%(i%, COUNT) = 4
						END IF
					CASE "Time Stop"
						timestop%(i%, TAG) = TRUE
						timestop%(i%, COUNT) = 4
					CASE "Permanence"
						perm%(i%, TAG) = TRUE
						perm%(i%, COUNT) = 4
					CASE "Delayed Effect"
						delayed%(i%, TAG) = TRUE
						delayed%(i%, COUNT) = 4
					END SELECT
				NEXT
			NEXT
		END IF
	NEXT

	'dispell: destroy monsters
	FOR i% = 1 TO spelers%
		IF dispell%(i%) THEN
			x = FNkillmonsters(i%)
			FOR element% = HEAT TO COLD
				elemental%(FNnextwiz%(i%, LEFT), element%) = FALSE
				elemental%(i%, element%) = FALSE
				elemental%(FNnextwiz%(i%, RIGHT), element%) = FALSE
			NEXT
		END IF
	NEXT

	'disenchant
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				FOR side% = LEFT TO RIGHT
					IF spell$(i%, side%, t%) = "Disenchant" THEN
						IF poison%(i%, TAG) OR disease%(i%, TAG) OR blind%(i%, TAG) AND NOT counter%(i%) OR mindcount%(i%) = 1 THEN
							victim% = i%
						ELSE
							victim% = FNnextwiz%(i%, side%)
							IF invis%(victim%, TAG) OR mirror%(victim%) THEN victim% = i%
						END IF
						IF NOT counter%(victim%) THEN
							IF NOT res%(victim%, PERMANENT, HEAT) THEN res%(victim%, TAG, HEAT) = FALSE
							IF NOT res%(victim%, PERMANENT, COLD) THEN res%(victim%, TAG, COLD) = FALSE
							IF NOT blind%(victim%, PERMANENT) THEN blind%(victim%, TAG) = FALSE
							IF NOT invis%(victim%, PERMANENT) THEN invis%(victim%, TAG) = FALSE
							IF NOT haste%(victim%, PERMANENT) THEN haste%(victim%, TAG) = FALSE
							IF NOT protect%(victim%, PERMANENT) THEN protect%(victim%, TAG) = FALSE
							perm%(victim%, TAG) = FALSE
							delayed%(victim%, TAG) = FALSE
							timestop%(victim%, TAG) = FALSE
							poison%(victim%, TAG) = FALSE
							disease%(victim%, TAG) = FALSE
							amnesia%(victim%) = FALSE
							confusion%(victim%) = FALSE
							paralysis%(victim%) = FALSE
							fear%(victim%) = FALSE
						END IF
					END IF
				NEXT
			NEXT
		END IF
	NEXT

	'healing
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				FOR side% = LEFT TO RIGHT
					SELECT CASE spell$(i%, side%, t%)
					CASE "Minor Heal"
						IF health%(i%) > 0 THEN
							health%(i%) = health%(i%) + 1
							IF health%(i%) > 15 THEN health%(i%) = 15
						END IF
					CASE "Major Heal"
						IF health%(i%) > 0 THEN
							health%(i%) = health%(i%) + 2
							IF health%(i%) > 15 THEN health%(i%) = 15
							disease%(i%, TAG) = FALSE
						END IF
					END SELECT
				NEXT
			NEXT
		END IF
	NEXT
  
	'counters
	FOR i% = 1 TO spelers%
		IF blind%(i%, COUNT) > 1 THEN
			blind%(i%, COUNT) = blind%(i%, COUNT) - 1
		ELSEIF NOT blind%(i%, PERMANENT) THEN
			blind%(i%, TAG) = FALSE
		END IF
		IF invis%(i%, COUNT) > 1 THEN
			invis%(i%, COUNT) = invis%(i%, COUNT) - 1
		ELSEIF NOT invis%(i%, PERMANENT) THEN
			invis%(i%, TAG) = FALSE
		END IF
		IF delayed%(i%, COUNT) > 1 THEN
			delayed%(i%, COUNT) = delayed%(i%, COUNT) - 1
		ELSE
			delayed%(i%, TAG) = FALSE
		END IF
		IF haste%(i%, COUNT) > 1 THEN
			haste%(i%, COUNT) = haste%(i%, COUNT) - 1
		ELSEIF NOT haste%(i%, PERMANENT) THEN
			haste%(i%, TAG) = FALSE
		END IF
		IF perm%(i%, COUNT) > 1 THEN
			perm%(i%, COUNT) = perm%(i%, COUNT) - 1
		ELSE
			perm%(i%, TAG) = FALSE
		END IF
		IF protect%(i%, COUNT) > 1 THEN
			protect%(i%, COUNT) = protect%(i%, COUNT) - 1
		ELSEIF NOT protect%(i%, PERMANENT) THEN
			protect%(i%, TAG) = FALSE
		END IF
		IF timestop%(i%, COUNT) > 1 THEN
			timestop%(i%, COUNT) = timestop%(i%, COUNT) - 1
		ELSE
			timestop%(i%, TAG) = FALSE
		END IF
		IF poison%(i%, COUNT) > 1 THEN
			poison%(i%, COUNT) = poison%(i%, COUNT) - 1
			IF poison%(i%, COUNT) = 0 THEN health%(i%) = 0
		END IF
		IF disease%(i%, COUNT) > 1 THEN
			disease%(i%, COUNT) = disease%(i%, COUNT) - 1
			IF disease%(i%, COUNT) = 0 THEN health%(i%) = 0
		END IF
	NEXT

	'raise dead
	FOR i% = 1 TO spelers%
		IF NOT dispell%(i%) THEN
			FOR t% = SPSTOP TO SPNORM
				raise% = FALSE
				IF spell$(i%, LEFT, t%) = "Raise Dead" THEN
					victim% = (i% + spelers% - 2) MOD spelers% + 1
					raise% = TRUE
				END IF
				IF spell$(i%, RIGHT, t%) = "Raise Dead" THEN
					victim% = i% MOD spelers% + 1
					raise% = TRUE
				END IF
				IF raise% THEN
					IF NOT alive%(victim%) THEN
						alive%(victim%) = TRUE
						health%(victim%) = 15
						control%(victim%) = control%(i%)
					END IF
				END IF
			NEXT
		END IF
	NEXT
	FNresolvespells = TRUE
END DEF

DEF FNendseq% (index%, side%, word$)
	IF RIGHT$(sequence$(index%, side%), LEN(word$)) = word$ THEN
		FNendseq% = TRUE
	ELSE
		FNendseq% = FALSE
	END IF
END DEF

DEF FNreadspells (index%, time%)
	IF NOT alive%(index%) THEN
		spell$(index%, LEFT, time%) = ""
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, LEFT, "p") AND FNendseq%(index%, RIGHT, "p") THEN
		spell$(index%, LEFT, time%) = "Surrender"
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, LEFT, "c") THEN
		IF FNendseq%(index%, LEFT, "wddc") THEN
			spell$(index%, LEFT, time%) = "Special Bolt"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "wddc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Special Bolt"
		ELSEIF FNendseq%(index%, LEFT, "dsfffc") THEN
			spell$(index%, LEFT, time%) = "Disease"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "dsfffc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Disease"
		ELSEIF FNendseq%(index%, LEFT, "sppc") THEN
			spell$(index%, LEFT, time%) = "Time Stop"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "sppc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Time Stop"
		ELSEIF FNendseq%(index%, LEFT, "wssc") THEN
			spell$(index%, LEFT, time%) = "Ice Storm"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "wssc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Ice Storm"
		ELSEIF FNendseq%(index%, LEFT, "dwwfwc") THEN
			spell$(index%, LEFT, time%) = "Raise Dead"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "dwwfwc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Raise Dead"
		ELSEIF FNendseq%(index%, LEFT, "pwpwwc") THEN
			spell$(index%, LEFT, time%) = "Haste"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "pwpwwc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Haste"
		ELSEIF FNendseq%(index%, LEFT, "swwc") THEN
			spell$(index%, LEFT, time%) = "Fire Storm"
			spell$(index%, RIGHT, time%) = ""
		ELSEIF FNendseq%(index%, RIGHT, "swwc") THEN
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = "Fire Storm"
		ELSE
			spell$(index%, LEFT, time%) = ""
			spell$(index%, RIGHT, time%) = ""
		END IF
	ELSEIF FNendseq%(index%, LEFT, "dwffd") AND FNendseq%(index%, RIGHT, "d") THEN
		spell$(index%, LEFT, time%) = "Blindness"
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, LEFT, "d") AND FNendseq%(index%, RIGHT, "dwffd") THEN
		spell$(index%, LEFT, time%) = ""
		spell$(index%, RIGHT, time%) = "Blindness"
	ELSEIF FNendseq%(index%, LEFT, "ppws") AND FNendseq%(index%, RIGHT, "ws") THEN
		spell$(index%, LEFT, time%) = "Invisibility"
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, LEFT, "ws") AND FNendseq%(index%, RIGHT, "ppws") THEN
		spell$(index%, LEFT, time%) = ""
		spell$(index%, RIGHT, time%) = "Invisibility"
	ELSEIF FNendseq%(index%, LEFT, "cw") AND FNendseq%(index%, RIGHT, "cw") THEN
		spell$(index%, LEFT, time%) = "Magic Mirror"
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, LEFT, "cdpw") THEN
		spell$(index%, LEFT, time%) = "Dispell Magic"
		spell$(index%, RIGHT, time%) = ""
	ELSEIF FNendseq%(index%, RIGHT, "cdpw") THEN
		spell$(index%, LEFT, time%) = ""
		spell$(index%, RIGHT, time%) = "Dispell Magic"
	ELSE
		FOR side% = LEFT TO RIGHT
			IF FNendseq%(index%, side%, "x") THEN
				spell$(index%, side%, time%) = "Stab"
			ELSEIF FNendseq%(index%, side%, "dffdd") THEN
				spell$(index%, side%, time%) = "Lightning Bolt"
			ELSEIF FNendseq%(index%, side%, "psdd") THEN
				spell$(index%, side%, time%) = "Charm Monster"
			ELSEIF FNendseq%(index%, side%, "fssdd") THEN
				spell$(index%, side%, time%) = "Fireball"
			ELSEIF FNendseq%(index%, side%, "wpfd") THEN
				spell$(index%, side%, time%) = "Major Harm"
			ELSEIF FNendseq%(index%, side%, "pwpfsssd") THEN
				spell$(index%, side%, time%) = "Finger of Death"
			ELSEIF FNendseq%(index%, side%, "sd") THEN
				spell$(index%, side%, time%) = "Missile"
			ELSEIF FNendseq%(index%, side%, "dwwfwd") THEN
				spell$(index%, side%, time%) = "Poison"
			ELSEIF FNendseq%(index%, side%, "swd") THEN
				spell$(index%, side%, time%) = "Fear"
			ELSEIF FNendseq%(index%, side%, "psdf") THEN
				spell$(index%, side%, time%) = "Charm Person"
			ELSEIF FNendseq%(index%, side%, "fff") THEN
				spell$(index%, side%, time%) = "Paralyze"
			ELSEIF FNendseq%(index%, side%, "spf") THEN
				spell$(index%, side%, time%) = "Scramble"
			ELSEIF FNendseq%(index%, side%, "dsf") THEN
				spell$(index%, side%, time%) = "Confusion"
			ELSEIF FNendseq%(index%, side%, "ssfp") THEN
				spell$(index%, side%, time%) = "Resist Cold"
			ELSEIF FNendseq%(index%, side%, "wwfp") THEN
				spell$(index%, side%, time%) = "Resist Heat"
			ELSEIF FNendseq%(index%, side%, "wfp") THEN
				spell$(index%, side%, time%) = "Minor Harm"
			ELSEIF FNendseq%(index%, side%, "dpp") THEN
				spell$(index%, side%, time%) = "Amnesia"
			ELSEIF FNendseq%(index%, side%, "wpp") THEN
				spell$(index%, side%, time%) = "Counterspell"
			ELSEIF FNendseq%(index%, side%, "dwsssp") THEN
				spell$(index%, side%, time%) = "Delayed Effect"
			ELSEIF FNendseq%(index%, side%, "pdwp") THEN
				spell$(index%, side%, time%) = "Disenchant"
			ELSEIF FNendseq%(index%, side%, "wwp") THEN
				spell$(index%, side%, time%) = "Protection"
			ELSEIF FNendseq%(index%, side%, "p") THEN
				spell$(index%, side%, time%) = "Shield"
			ELSEIF FNendseq%(index%, side%, "cswws") THEN
				IF side% = LEFT THEN
					spell$(index%, LEFT, time%) = "Elemental"
				ELSEIF spell$(index%, LEFT, time%) <> "Elemental" THEN
					spell$(index%, RIGHT, time%) = "Elemental"
				END IF
			ELSEIF FNendseq%(index%, side%, "wws") THEN
				spell$(index%, side%, time%) = "Counterspell"
			ELSEIF FNendseq%(index%, side%, "spfpsdw") THEN
				spell$(index%, side%, time%) = "Permanence"
			ELSEIF FNendseq%(index%, side%, "dfw") THEN
				spell$(index%, side%, time%) = "Minor Heal"
			ELSEIF FNendseq%(index%, side%, "wfpsfw") THEN
				spell$(index%, side%, time%) = "Summon Giant"
			ELSEIF FNendseq%(index%, side%, "fpsfw") THEN
				spell$(index%, side%, time%) = "Summon Troll"
			ELSEIF FNendseq%(index%, side%, "psfw") THEN
				spell$(index%, side%, time%) = "Summon Ogre"
			ELSEIF FNendseq%(index%, side%, "sfw") THEN
				spell$(index%, side%, time%) = "Summon Goblin"
			ELSEIF FNendseq%(index%, side%, "dfpw") THEN
				spell$(index%, side%, time%) = "Major Heal"
			ELSE
				spell$(index%, side%, time%) = ""
			END IF
		NEXT
	END IF
	FNreadspells = TRUE
END DEF

DEF FNinputsignals (index%, time%)
	CLS
	LOCATE 12, 25
	PRINT wizname$(index%); " to gesture."
	x = FNpresskey
	x = FNshowwizards(index%)
	COLOR 15
	IF time% = SPSTOP THEN
		PRINT "The next gestures are from your Time Stop."
	ELSEIF time% = SPHASTE THEN
		PRINT "The next gestures are from your Haste."
	END IF
	COLOR 7
	IF amnesia%(index%) THEN
		PRINT "As you suffer from amnesia, you repeat your previous gestures."
		x = FNpresskey
		newsign$(index%, LEFT) = RIGHT$(sequence$(index%, LEFT), 1)
		newsign$(index%, RIGHT) = RIGHT$(sequence$(index%, RIGHT), 1)
	ELSEIF confusion%(index%) THEN
		Q! = RND
		IF (Q! < 1 / 6) THEN
				tempconf$ = "d"
		ELSEIF (Q! < 1 / 3) THEN
				tempconf$ = "f"
		ELSEIF (Q! < 1 / 2) THEN
				tempconf$ = "p"
		ELSEIF (Q! < 2 / 3) THEN
				tempconf$ = "s"
		ELSEIF (Q! < 5 / 6) THEN
			tempconf$ = "w"
		ELSE
			tempconf$ = "c"
		END IF
		IF tempconf$ = "c" THEN
			PRINT "Confused, you clap your hands."
			newsign$(index%, LEFT) = "c"
			newsign$(index%, RIGHT) = "c"
			x = FNpresskey
		ELSE
			IF RND < .5 THEN
				PRINT "You're confused. Your right hand gestures ";
				normal% = LEFT
				conf% = RIGHT
			ELSE
				PRINT "You're confused. Your left hand gestures ";
				normal% = RIGHT
				conf% = LEFT
			END IF
			PRINT "'"; tempconf$; "'."
			DO
				ok% = FALSE
				INPUT "What gesture do you make with your other hand"; tempnorm$
				tempnorm$ = LEFT$(LCASE$(tempnorm$), 1)
				SELECT CASE tempnorm$
				CASE "d", "f", "p", "s", "w", "x"
					newsign$(index%, conf%) = tempconf$
					newsign$(index%, normal%) = tempnorm$
					ok% = TRUE
				CASE "c"
					PRINT "Can only clap with both hands!"
				CASE ELSE
					PRINT "Please specify gestures with d/f/p/s/w/c/x."
				END SELECT
			LOOP WHILE NOT ok%
		END IF
	ELSEIF paralysis%(index%) THEN
		IF RND < .5 THEN
			PRINT "Your left hand has been paralyzed and now gestures ";
			normal% = RIGHT
			para% = LEFT
		ELSE
			PRINT "Your right hand has been paralyzed and now gestures ";
			normal% = LEFT
			para% = RIGHT
		END IF
		temppara$ = RIGHT$(sequence$(index%, para%), 1)
		SELECT CASE temppara$
		CASE "s"
			temppara$ = "d"
		CASE "w"
			temppara$ = "p"
		CASE "c"
			temppara$ = "f"
		END SELECT
		PRINT "'"; temppara$; "'."
		DO
			ok% = FALSE
			INPUT "What gesture do you make with your other hand"; tempnorm$
			tempnorm$ = LEFT$(LCASE$(tempnorm$), 1)
			SELECT CASE tempnorm$
			CASE "d", "f", "p", "s", "w", "x"
				newsign$(index%, para%) = temppara$
				newsign$(index%, normal%) = tempnorm$
				ok% = TRUE
			CASE "c"
				PRINT "Can only clap with both hands!"
			CASE ELSE
				PRINT "Please specify gestures with d/f/p/s/w/c/x."
			END SELECT
		LOOP WHILE NOT ok%
	ELSEIF fear%(index%) THEN
		DO
			ok% = FALSE
			PRINT "Gestures: P)alm, W)ave, or X for Stab"
			INPUT "What is your left-hand gesture"; templeft$
			templeft$ = LEFT$(LCASE$(templeft$), 1)
			IF FNnogesture%(templeft$) THEN
				PRINT "Please specify gestures with d/f/p/s/w/c/x."
			ELSEIF templeft$ = "d" OR templeft$ = "f" OR templeft$ = "s" OR templeft$ = "c" THEN
				PRINT "You are to frightened to make this gesture."
			ELSE
				INPUT "What is your right-hand gesture"; tempright$
				tempright$ = LEFT$(LCASE$(tempright$), 1)
				IF tempright$ = "d" OR tempright$ = "f" OR tempright$ = "s" OR tempright$ = "c" THEN
					PRINT "You are to frightened to make this gesture."
				ELSEIF FNnogesture%(templeft$) THEN
					PRINT "Please specify gestures with d/f/p/s/w/c/x."
				ELSEIF tempright$ = "x" AND templeft$ = "x" THEN
					PRINT "Can only stap with one hand!"
				ELSE
					newsign$(index%, LEFT) = templeft$
					newsign$(index%, RIGHT) = tempright$
					ok% = TRUE
				END IF
			END IF
		LOOP WHILE NOT ok%
	ELSE
		DO
			ok% = FALSE
			PRINT "Gestures: D)igit, F)inger, P)alm, S)nap, W)ave, C)lap or X for Stab"
			IF charmed%(index%, TAG) THEN
				COLOR 15
				PRINT "As you have been charmed, ";
				PRINT wizname$(charmed%(index%, COUNT));
				PRINT " may now decide on your left-hand gesture!"
				COLOR 7
			END IF
			IF control%(index%) <> index% THEN
				COLOR 15
				PRINT "As you are under control, ";
				PRINT wizname$(charmed%(index%, COUNT));
				PRINT " may decide on your gestures!"
				COLOR 7
			END IF
			INPUT "What is your left-hand gesture"; templeft$
			templeft$ = LEFT$(LCASE$(templeft$), 1)
			IF templeft$ = "c" THEN
				newsign$(index%, LEFT) = "c"
				newsign$(index%, RIGHT) = "c"
				ok% = TRUE
			ELSEIF FNnogesture%(templeft$) THEN
				PRINT "Please specify gestures with d/f/p/s/w/c/x."
			ELSE
				INPUT "What is your right-hand gesture"; tempright$
				tempright$ = LEFT$(LCASE$(tempright$), 1)
				IF tempright$ = "c" THEN
					PRINT "Can only clap with both hands!"
				ELSEIF FNnogesture%(tempright$) THEN
					PRINT "Please specify gestures with d/f/p/s/w/c/x."
				ELSEIF tempright$ = "x" AND templeft$ = "x" THEN
					PRINT "Can only stab with one hand!"
				ELSE
					newsign$(index%, LEFT) = templeft$
					newsign$(index%, RIGHT) = tempright$
					ok% = TRUE
				END IF
			END IF
		LOOP WHILE NOT ok%
	END IF
	FNinputsignals = TRUE
END DEF

x = FNinit
WHILE levenden% >= 2
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) THEN
			IF timestop%(wizard%, TAG) THEN
				x = FNinputsignals(wizard%, SPSTOP)
			ELSE
				spell$(wizard%, LEFT, SPSTOP) = ""
				spell$(wizard%, RIGHT, SPSTOP) = ""
			END IF
		END IF
	NEXT
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) AND timestop%(wizard%, TAG) THEN
			x = FNshiftsequence(wizard%, TRUE)
		END IF
	NEXT
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) THEN
			IF haste%(wizard%, TAG) THEN
				x = FNinputsignals(wizard%, SPHASTE)
			ELSE
				spell$(wizard%, LEFT, SPHASTE) = ""
				spell$(wizard%, RIGHT, SPHASTE) = ""
			END IF
		END IF
	NEXT
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) AND haste%(wizard%, TAG) THEN
			x = FNshiftsequence(wizard%, TRUE)
		END IF
	NEXT
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) THEN x = FNinputsignals(wizard%, SPNORM)
	NEXT
	FOR wizard% = 1 TO spelers%
		IF alive%(wizard%) THEN
			IF timestop%(wizard%, TAG) THEN
				x = FNreadspells(wizard%, SPSTOP)
			END IF
			IF haste%(wizard%, TAG) THEN
				x = FNreadspells(wizard%, SPHASTE)
			END IF
			x = FNshiftsequence(wizard%, invis%(wizard%, TAG))
			x = FNreadspells(wizard%, SPNORM)
		END IF
	NEXT
	x = FNresolvespells
	x = FNcheckforkills
WEND
x = FNextro

